@echo off
cd %~dp0
setlocal enabledelayedexpansion
title Games Explorer for Windows 10 Installer

:: Variables
set GAMEUX_LOCALE=en-US

if "%~1" == "/locale" (
    if NOT "%~2" == "" (
        set GAMEUX_LOCALE=%2
    )
)

set GAMEUX_SYS32=gameux.dll GameUXLegacyGDFs.dll migration\gameuxmig.dll
set GAMEUX_SYS32_MUIS=gameux.dll.mui
set GAMEUX_WOW64=gameux.dll migration\gameuxmig.dll
set GAMEUX_WOW64_MUIS=gameux.dll.mui

:: Texts
cls
echo.
echo Games Explorer for Windows 10
echo ==========================================================================
echo.

:: Check for admin.
net session >nul 2>&1
if NOT %ERRORLEVEL% == 0 (
    goto noadmin
)

echo This batch script will replace system files to restore the Games Explorer from
echo Windows 10 v1709 in newer Windows 10. Only MUIs for en-US are provided by
echo default. If you want to install this for another locale, grab those files from
echo Windows 10 v1709, create a folder next to all of the "en-US" folders in the
echo "files" folder, and put your files in there.
echo.
echo   Locale to install: %GAMEUX_LOCALE%
echo.
echo If that locale is incorrect, please exit this script and pass your proper locale
echo with the /locale argument.
echo.

choice /n /m "Do you wish to continue? Doing so will replace system files. (Y/N)"

:: User said no
if %ERRORLEVEL% == 2 (
    goto end
)

:: INSTALL
cls

:: Registry
echo.
echo|set /p="Importing registry keys..."
call "%~dp0bin\psexec64" -accepteula -s -i regedit /s "%~dp0regs\gameux.reg" >nul 2>&1
echo done.

:: Reset title
title Games Explorer for Windows 10 Installer

echo.

:: Files
echo Copying files...

:: DLLs
@REM for %%f in (%GAMEUX_FILES%) do call "%~dp0scripts\ownreplace" %SystemRoot%\System32\%%f %~dp0files\%%f
@REM call "%~dp0scripts\ownreplace" %SystemRoot%\System32\authui.dll %~dp0files\%GAMEUX_AUTHUI%

for %%f in (%GAMEUX_SYS32%) do call "%~dp0scripts\ownreplace" %SystemRoot%\System32\%%f %~dp0files\System32\%%f
for %%f in (%GAMEUX_WOW64%) do call "%~dp0scripts\ownreplace" %SystemRoot%\SysWOW64\%%f %~dp0files\SysWOW64\%%f

:: MUIs
for %%f in (%GAMEUX_SYS32_MUIS%) do call "%~dp0scripts\ownreplace" %SystemRoot%\System32\%GAMEUX_LOCALE%\%%f %~dp0files\System32\%GAMEUX_LOCALE%\%%f
for %%f in (%GAMEUX_WOW64_MUIS%) do call "%~dp0scripts\ownreplace" %SystemRoot%\SysWOW64\%GAMEUX_LOCALE%\%%f %~dp0files\SysWOW64\%GAMEUX_LOCALE%\%%f

echo.
echo The Games Explorer has been installed. You can launch it with the following command:
echo shell:::{ED228FDF-9EA8-4870-83B1-96B02CFE0D52}
echo.
pause
goto end

:noadmin
echo You must run this script as administrator. Right click the script and click
echo Run as Administrator, and if you need to pass arguments, run it in a Command
echo Prompt window that is running as administrator.
echo.
pause
goto end

:end
cls